// Code generated by applyconfiguration-gen. DO NOT EDIT.

package v1

import (
	apiauthorizationv1 "github.com/openshift/api/authorization/v1"
	internal "github.com/openshift/client-go/authorization/applyconfigurations/internal"
	runtime "k8s.io/apimachinery/pkg/runtime"
	managedfields "k8s.io/apimachinery/pkg/util/managedfields"
	v1 "k8s.io/client-go/applyconfigurations/meta/v1"
)

// SubjectAccessReviewApplyConfiguration represents an declarative configuration of the SubjectAccessReview type for use
// with apply.
type SubjectAccessReviewApplyConfiguration struct {
	v1.TypeMetaApplyConfiguration `json:",inline"`
	ActionApplyConfiguration      `json:",inline"`
	User                          *string                            `json:"user,omitempty"`
	GroupsSlice                   []string                           `json:"groups,omitempty"`
	Scopes                        *apiauthorizationv1.OptionalScopes `json:"scopes,omitempty"`
}

// SubjectAccessReview constructs an declarative configuration of the SubjectAccessReview type for use with
// apply.
func SubjectAccessReview(name string) *SubjectAccessReviewApplyConfiguration {
	b := &SubjectAccessReviewApplyConfiguration{}
	b.WithKind("SubjectAccessReview")
	b.WithAPIVersion("authorization.openshift.io/v1")
	return b
}

// ExtractSubjectAccessReview extracts the applied configuration owned by fieldManager from
// subjectAccessReview. If no managedFields are found in subjectAccessReview for fieldManager, a
// SubjectAccessReviewApplyConfiguration is returned with only the Name, Namespace (if applicable),
// APIVersion and Kind populated. It is possible that no managed fields were found for because other
// field managers have taken ownership of all the fields previously owned by fieldManager, or because
// the fieldManager never owned fields any fields.
// subjectAccessReview must be a unmodified SubjectAccessReview API object that was retrieved from the Kubernetes API.
// ExtractSubjectAccessReview provides a way to perform a extract/modify-in-place/apply workflow.
// Note that an extracted apply configuration will contain fewer fields than what the fieldManager previously
// applied if another fieldManager has updated or force applied any of the previously applied fields.
// Experimental!
func ExtractSubjectAccessReview(subjectAccessReview *apiauthorizationv1.SubjectAccessReview, fieldManager string) (*SubjectAccessReviewApplyConfiguration, error) {
	return extractSubjectAccessReview(subjectAccessReview, fieldManager, "")
}

// ExtractSubjectAccessReviewStatus is the same as ExtractSubjectAccessReview except
// that it extracts the status subresource applied configuration.
// Experimental!
func ExtractSubjectAccessReviewStatus(subjectAccessReview *apiauthorizationv1.SubjectAccessReview, fieldManager string) (*SubjectAccessReviewApplyConfiguration, error) {
	return extractSubjectAccessReview(subjectAccessReview, fieldManager, "status")
}

func extractSubjectAccessReview(subjectAccessReview *apiauthorizationv1.SubjectAccessReview, fieldManager string, subresource string) (*SubjectAccessReviewApplyConfiguration, error) {
	b := &SubjectAccessReviewApplyConfiguration{}
	err := managedfields.ExtractInto(subjectAccessReview, internal.Parser().Type("com.github.openshift.api.authorization.v1.SubjectAccessReview"), fieldManager, b, subresource)
	if err != nil {
		return nil, err
	}

	b.WithKind("SubjectAccessReview")
	b.WithAPIVersion("authorization.openshift.io/v1")
	return b, nil
}

// WithKind sets the Kind field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Kind field is set to the value of the last call.
func (b *SubjectAccessReviewApplyConfiguration) WithKind(value string) *SubjectAccessReviewApplyConfiguration {
	b.Kind = &value
	return b
}

// WithAPIVersion sets the APIVersion field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the APIVersion field is set to the value of the last call.
func (b *SubjectAccessReviewApplyConfiguration) WithAPIVersion(value string) *SubjectAccessReviewApplyConfiguration {
	b.APIVersion = &value
	return b
}

// WithNamespace sets the Namespace field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Namespace field is set to the value of the last call.
func (b *SubjectAccessReviewApplyConfiguration) WithNamespace(value string) *SubjectAccessReviewApplyConfiguration {
	b.Namespace = &value
	return b
}

// WithVerb sets the Verb field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Verb field is set to the value of the last call.
func (b *SubjectAccessReviewApplyConfiguration) WithVerb(value string) *SubjectAccessReviewApplyConfiguration {
	b.Verb = &value
	return b
}

// WithGroup sets the Group field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Group field is set to the value of the last call.
func (b *SubjectAccessReviewApplyConfiguration) WithGroup(value string) *SubjectAccessReviewApplyConfiguration {
	b.Group = &value
	return b
}

// WithVersion sets the Version field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Version field is set to the value of the last call.
func (b *SubjectAccessReviewApplyConfiguration) WithVersion(value string) *SubjectAccessReviewApplyConfiguration {
	b.Version = &value
	return b
}

// WithResource sets the Resource field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Resource field is set to the value of the last call.
func (b *SubjectAccessReviewApplyConfiguration) WithResource(value string) *SubjectAccessReviewApplyConfiguration {
	b.Resource = &value
	return b
}

// WithResourceName sets the ResourceName field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the ResourceName field is set to the value of the last call.
func (b *SubjectAccessReviewApplyConfiguration) WithResourceName(value string) *SubjectAccessReviewApplyConfiguration {
	b.ResourceName = &value
	return b
}

// WithPath sets the Path field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Path field is set to the value of the last call.
func (b *SubjectAccessReviewApplyConfiguration) WithPath(value string) *SubjectAccessReviewApplyConfiguration {
	b.Path = &value
	return b
}

// WithIsNonResourceURL sets the IsNonResourceURL field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the IsNonResourceURL field is set to the value of the last call.
func (b *SubjectAccessReviewApplyConfiguration) WithIsNonResourceURL(value bool) *SubjectAccessReviewApplyConfiguration {
	b.IsNonResourceURL = &value
	return b
}

// WithContent sets the Content field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Content field is set to the value of the last call.
func (b *SubjectAccessReviewApplyConfiguration) WithContent(value runtime.RawExtension) *SubjectAccessReviewApplyConfiguration {
	b.Content = &value
	return b
}

// WithUser sets the User field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the User field is set to the value of the last call.
func (b *SubjectAccessReviewApplyConfiguration) WithUser(value string) *SubjectAccessReviewApplyConfiguration {
	b.User = &value
	return b
}

// WithGroupsSlice adds the given value to the GroupsSlice field in the declarative configuration
// and returns the receiver, so that objects can be build by chaining "With" function invocations.
// If called multiple times, values provided by each call will be appended to the GroupsSlice field.
func (b *SubjectAccessReviewApplyConfiguration) WithGroupsSlice(values ...string) *SubjectAccessReviewApplyConfiguration {
	for i := range values {
		b.GroupsSlice = append(b.GroupsSlice, values[i])
	}
	return b
}

// WithScopes sets the Scopes field in the declarative configuration to the given value
// and returns the receiver, so that objects can be built by chaining "With" function invocations.
// If called multiple times, the Scopes field is set to the value of the last call.
func (b *SubjectAccessReviewApplyConfiguration) WithScopes(value apiauthorizationv1.OptionalScopes) *SubjectAccessReviewApplyConfiguration {
	b.Scopes = &value
	return b
}
